
// zlib open source license
//
// Copyright (c) 2010 to 2013 David Forsgren Piuva
// 
// This software is provided 'as-is', without any express or implied
// warranty. In no event will the authors be held liable for any damages
// arising from the use of this software.
// 
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it
// freely, subject to the following restrictions:
// 
//    1. The origin of this software must not be misrepresented; you must not
//    claim that you wrote the original software. If you use this software
//    in a product, an acknowledgment in the product documentation would be
//    appreciated but is not required.
// 
//    2. Altered source versions must be plainly marked as such, and must not be
//    misrepresented as being the original software.
// 
//    3. This notice may not be removed or altered from any source
//    distribution.

#pragma once

#define QASmallestSize 4

struct QARect {
	float MinU;
	float MaxU;
	float MinV;
	float MaxV;
};

class QuadAllocator
{
private:
	int HeapCount[QASmallestSize + 1];
	QARect HeapArea[QASmallestSize + 1][4];
	void Split(int Size);
	bool Divide(int Size);
public:
	QuadAllocator(void) {
		Reset();
	}
	void Reset(void);
	QARect Allocate(int Size);
	QARect MakeQARect(float MinU, float MaxU, float MinV, float MaxV) {
		QARect Result;
		Result.MinU = MinU;
		Result.MaxU = MaxU;
		Result.MinV = MinV;
		Result.MaxV = MaxV;
		return Result;
	}
};
